#ifndef COMPUTATION_H
#define COMPUTATION_H
#include "main.h"

bool dbl(natural_t *nat);
bool inc(natural_t *nat, size_t p);
bool hlv(natural_t *nat);

rit_genus_t rit_genus(natural_t *nat);
bool rit_geni_equal(rit_genus_t g, rit_genus_t h);
bool dbl_rit(natural_t *nat, rit_genus_t *gen);

void free_xit_rit_mapping();
bool build_xit_rit_mapping(computation_t *computation);
bool new_computation(pargs_t *pargs, computation_t *computation);
void free_computation(computation_t *computation);

bool compute_computation(pargs_t *pargs, computation_t *computation);
bool edit_computation(pargs_t *pargs, computation_t *computation);

bool fprint_as_ternary(FILE *f, bool plus_one, uint64_t n
                      , computation_t *computation);
int fprint_rits(FILE *f, natural_t *nat);
int fprint_rits_reversed(FILE *f, natural_t *nat);
int fprint_rits_as_expression(FILE *f, natural_t *nat);
int fprint_natural(FILE* f, natural_t *nat);
int fprint_computation(FILE *file, char *filename, computation_t *computation);

#endif
