#ifndef FILEIO_H
#define FILEIO_H
#include "main.h"

bool write_EOF(FILE *f);
bool read_EOF(FILE *f);

bool write_byte(uint8_t byte, FILE *f);
bool read_byte(uint8_t *byte, FILE *f);
bool check_byte(const char *msg, uint8_t byte, FILE *f);

bool write_bool(bool boolean, FILE *f);
bool read_bool(bool *boolean, FILE *f);

bool write_str(char *str, FILE *f);
bool check_str(const char *msg, char *str, FILE *f);

bool read_nstr(size_t n, char **str, FILE *f);

bool write_size_t(size_t size, FILE *f);
bool read_size_t(size_t *size, FILE *f);

bool write_uint64_t(uint64_t n, FILE *f);
bool read_uint64_t(uint64_t *n, FILE *f);

bool write_xit_t(xit_t x, FILE *f);
bool read_xit_t(xit_t *x, FILE *f);

bool write_uint64_ts(size_t size, uint64_t *ns, FILE *f);
bool read_uint64_ts(size_t size, uint64_t **ns, FILE *f);

bool write_xit_ts(size_t size, xit_t *xits, FILE *f);
bool read_xit_ts(size_t size, xit_t **xits, FILE *f);
bool read_xit_ts_overallocating(size_t maxsize, size_t size, xit_t **xits, FILE *f);

bool write_natural_t(natural_t *nat, FILE *f);
bool read_natural_t(natural_t *nat, FILE *f);

bool write_natural_ts(size_t size, natural_t *nats, FILE *f);
bool read_natural_ts(size_t size, natural_t **nats, FILE *f);

bool write_computation(char *filename, computation_t *computation);
bool read_computation(char *filename, computation_t *computation);

#endif
