#!/bin/bash

# Jonathan Frech, 2nd of October 2019

valids='valids.txt'
times='times.txt'
sorted_times='sorted_times.txt'

if [ ! -f $valids ]; then
    echo "Generating '$valids' ..." 1>&2
    ./generate_valids.sh > $valids
    echo "Generated '$valids'." 1>&2
fi

if [ ! -f $times ]; then
    echo "Generating '$times' ..." 1>&2
    ./generate_times.sh > $times
    echo "Generated '$times'." 1>&2
fi

{
    head --lines 2 $times
    echo '# The following terms have been sorted.'
    echo ''
    tail --lines +5 $times | sort --sort=general-numeric
} > $sorted_times

head $sorted_times
