#!/bin/bash

# Jonathan Frech, 1st, 2nd, 3rd of October 2019
# Times a056154 using valid parameters.

in_filename='valids.txt'
tmp_filename='~tmp.dat'
target='10000'
runs='8'

echo '# Tests performed on an Intel(R) Core(TM) i7-4790K CPU @ 4.00GHz, running Linux Mint 19.2 Tina.'
echo "# $(date)"
echo "# (time average, in seconds, over $runs runs) target xit_t xit_carry_t rit_count_t threepow pass"
echo ''

while read -r xit_t xit_carry_t rit_count_t threepow; do
    #echo "xit_t=$xit_t xit_carry_t=$xit_carry_t rit_count_t=$rit_count_t threepow=$threepow"
    rm -f $tmp_filename
    make xit_t=$xit_t xit_carry_t=$xit_carry_t rit_count_t=$rit_count_t 1>/dev/null # 2>/dev/null
    ./a056154 --new $tmp_filename --3^$threepow # 1>/dev/null 2>/dev/null

    #one_run=$(./a056154 --target=$target -c $tmp_filename --nosave --print_time | tail --lines=1)
    for pass in '--' '--one-pass'; do
        >&2 echo "Timing \"$target $xit_t $xit_carry_t $rit_count_t $threepow $pass\" for $runs runs ..."
        times="(0"
        for j in $(eval echo "{1..$runs}"); do
            read -r cs xt xct rct itl_n fin_n < <(./a056154 --target=$target -c $tmp_filename --nosave --print_time $pass | tail --lines=1)
            times="$times+$cs"
        done
        times="$times)/$runs"
        time_average=$(echo "scale=4; $times" | bc -l)
        echo "$time_average $target $xit_t $xit_carry_t $rit_count_t $threepow $pass"
    done
done < <(tail --lines=+4 $in_filename)

rm -f $tmp_filename
