#!/bin/bash

# Jonathan Frech, 1st, 2nd of October 2019
# Generates valid combinations of the parameters
#     { xit_t, xit_carry_t, rit_count_t, threepow },
# where *_t are each one of
#     { uint8_t, uint16_t, uint32_t, uint64_t}
# and threepow is one of
#     { 1, 2, ..., 16 },
# where target = 50'000'000.

uints='uint8_t uint16_t uint32_t uint64_t'
target='50000000'
tmp_filename='~tmp.dat'

echo "# Valid combinations of the parameters"
echo "#     { xit_t, xit_carry_t, rit_count_t, threepow }."
echo ""

for xit_t in $uints; do
    for xit_carry_t in $uints; do
        for rit_count_t in $uints; do
            for threepow in {1..16}; do
                >&2 echo "? xit_t=$xit_t xit_carry_t=$xit_carry_t rit_count_t=$rit_count_t threepow=$threepow"
                rm -f $tmp_filename
                make xit_t=$xit_t xit_carry_t=$xit_carry_t rit_count_t=$rit_count_t 1>/dev/null
                if [ $? -eq 0 ]; then
                    ./a056154 --new $tmp_filename --3^$threepow 1>/dev/null
                    if [ $? -eq 0 ]; then
                        ./a056154 --target=$target -c $tmp_filename --nosave --print_time --only_verify_rit_count_t 1>/dev/null
                        if [ $? -eq 0 ]; then
                            >&2 echo "! xit_t=$xit_t xit_carry_t=$xit_carry_t rit_count_t=$rit_count_t threepow=$threepow"
                            echo "$xit_t $xit_carry_t $rit_count_t $threepow"
                        fi
                    fi
                fi
            done
        done
    done
done

rm -f $tmp_filename
