#ifndef MAIN_H
#define MAIN_H

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <unistd.h>
#include <time.h>
#include <inttypes.h>

#include <math.h>

#include "datatypes.h"
#include "computation.h"
#include "pargs.h"
#include "fileio.h"
#include "util.h"


/* Implement `log2` using `log`. */
#define LOG2

#define MAGIC_NUMBER "A056154-DATA"

#define STDLOG stderr
#define LOG_INIT \
 (void) (do_log && fprintf(STDLOG, "[%s] ", __func__))
#define LOG_INTR_WITH(FPRINT, ...) \
 (void) (do_log && FPRINT(STDLOG, __VA_ARGS__))
#define LOG_INTR(...) \
 LOG_INTR_WITH(fprintf, __VA_ARGS__)
#define LOG_FNAL \
 (void) (do_log && fprintf(STDLOG, "\n")), fflush(STDLOG)

#define LOG(...) \
 LOG_INIT, LOG_INTR(__VA_ARGS__), LOG_FNAL
#define ERROR(...) \
 fprintf(stderr, "[*** %s] ", __func__), fprintf(stderr, __VA_ARGS__), fprintf(stderr, "\n")

#define MALLOC_ERROR() \
 ERROR("Memory allocation failed.")
#define REALLOC_ERROR() \
 ERROR("Memory re-allocation failed.")
#define FILE_WRITE_ERROR(FILENAME) \
 ERROR("Writing to the file named '%s' failed.", FILENAME)
#define FILE_READ_ERROR(FILENAME) \
 ERROR("Reading from the file named '%s' failed.", FILENAME)

extern rit_count_t *xrl0map, *xr0map, *xr1map, *xr2map;
extern bool do_log;
extern uint64_t save_frequency_n, save_frequency_seconds,
                save_frequency_seconds_update_frequency_n;
extern const uint64_t max_target;
extern const xit_t radix;
extern const size_t n_xits_max;
extern const uint64_t default_three_pow;

#endif
