#include "util.h"

#ifdef LOG2
double log2(double x) {
 return log(x) / log(2); }
#endif


bool str_prefix(char *str, char *pre) {
 return !*pre || (*str == *pre && str_prefix(++str, ++pre)); }
bool str_equal(char *str, char *ztr) {
 return str_prefix(str, ztr) && str_prefix(ztr, str); }
size_t str_len(char *str) {
 return str && *str ? 1 + str_len(++str) : 0; }


int fprint_escaped(FILE *f, char *str) {
 int chars = 0;
 for (char c; (c = *str); str++)
  if (' ' <= c && c <= '~') fputc(c, f), chars++;
  else chars += fprintf(f, "\\x%02X", c);
 return chars; }

int fprint_byte_size(FILE *f, size_t bytes) {
 bool long_representation = false;
 if (long_representation && bytes == 1) return fprintf(f, "1 byte");

 #define GO(P, PNAME, PNAME_LONG, PREC) \
  if (bytes >> (10*P)) \
   return fprintf(f, long_representation ? ("%.*f" PNAME_LONG) \
          : ("%.*f" PNAME), PREC, (double) bytes / ((size_t) 1 << (10*P)));
 GO(4, "TiB", " tebibytes", 2)
 GO(3, "GiB", " gibibytes", 2)
 GO(2, "MiB", " mebibytes", 2)
 GO(1, "KiB", " kibibytes", 2)
 GO(0, "B"  , " bytes"    , 0)
 #undef GO

 return 0; }


/* ceil(-infty) := 0 */
uint64_t intceillog(uint64_t b, uint64_t n) {
 return n > 1 ? 1 + intceillog(b, n/b) : 0; }

uint64_t intpow(uint64_t b, uint64_t e) {
 return e ? b * intpow(b, e-1) : 1; }
